package MT::Plugin::Belong2ParentCategories;
use strict;
use MT;
use MT::Plugin;
use MT::Entry;
use MT::FileInfo;
use MT::WeblogPublisher;

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::Belong2ParentCategories::ISA = qw(MT::Plugin);

my $plugin = new MT::Plugin::Belong2ParentCategories({
    name => 'Belong2ParentCategories',
    id   => 'Belong2ParentCategories',
    key  => 'belong2parentcategories',
    description => 'The entry belongs to the parent categories.',
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
    'version'   => $VERSION,
});

MT->add_plugin($plugin);

sub init_registry {
    my $plugin = shift;
    $plugin->registry( {
        callbacks => {
            'cms_post_save.entry'
                => \&_post_save_cb,
        },
   } );
}

sub _post_save_cb {
    my ($eh, $app, $entry, $original) = @_;
    my $blog = $app->blog;
    for my $cat ( @{$entry->categories || [] } )  {
        next if ( !$cat );
        for my $parent ( $cat->parent_categories ) {
            next if ( !$parent );
            require MT::Placement;
            my $place = MT::Placement->get_by_key( {
                                                     blog_id => $blog->id,
                                                     entry_id => $entry->id,
                                                     category_id => $parent->id,
                                                    } );
            unless ( $place->id ) {
                $place->is_primary(0);
                $place->save or die "Saving placement failed: ", $place->errstr;
            }
        }
    }
}

1;